#!/usr/bin/env ruby
# $Id: encrypt.rb,v 1.5 2014/08/07 13:44:19 rjs Exp $
#
# PDFlib PLOP: PDF Linearization, Optimization, Protection
# encryption sample
#

require './PLOP'

# parameters for the input document
in_filename = "PLOP-datasheet.pdf"
in_password = ""

# parameters for the output document
out_filename = "PLOP-datasheet-encrypted.pdf"
out_master = "DEMO"
out_user = "demo"
permissions = ""

# This is where input files live. Adjust as necessary.
searchpath = "../data"

# create a new PLOP object
plop = PLOP.new

begin
    plop.set_option("searchpath=" + searchpath)

    # open unprotected input file without any password
    optlist = "password {" + in_password + "} "
    if ((doc = plop.open_document(in_filename, optlist)) == -1)
	raise "ERROR: " + plop.get_errmsg()
    end

    # create the output file with a password
    optlist = "masterpassword {" + out_master + "} userpassword {" +
		out_user + "} permissions {" + permissions + "} input=#{doc}"
                
    if (plop.create_document(out_filename, optlist)== -1)
	raise "ERROR: " + plop.get_errmsg()
    end

    # close input and output files
    plop.close_document(doc, "")

rescue PLOPException => pe
    print pe.backtrace.join("\n")
    printf("PLOP exception occurred in encrypt:\n")
    print "[" + pe.get_errnum.to_s + "] " + pe.get_apiname + \
                        ": " + pe.get_errmsg + "\n"
rescue Exception => e
    print e.backtrace.join("\n") + "\n" + e.to_s + "\n"
ensure
    plop.delete() if plop
end
